--DROP INHERITANCE
CREATE FUNCTION drop_inheritance()
RETURNS BOOLEAN AS $$
DECLARE
    tables_cursor CURSOR FOR SELECT tablename FROM pg_tables WHERE tablename LIKE 'messages_%' ORDER BY tablename ASC;
    table_name CHAR(25);
BEGIN
    OPEN tables_cursor;
    LOOP
	FETCH tables_cursor INTO table_name;
	IF NOT FOUND THEN
	    EXIT;
	END IF;
	EXECUTE ( 'ALTER TABLE ' || table_name || ' NO INHERIT messages' );
	EXECUTE ( 'ALTER TABLE ' || table_name || ' NO INHERIT rmessages' );
    END LOOP;
    CLOSE tables_cursor;
    RETURN TRUE;
EXCEPTION
    WHEN OTHERS THEN
	RAISE NOTICE 'Error number:%', SQLSTATE;
	RETURN FALSE;
END;
$$
LANGUAGE plpgsql;
SELECT drop_inheritance();
DROP FUNCTION drop_inheritance();
--TURN OFF constraint_exclusion
ALTER DATABASE op5lsu SET constraint_exclusion = off;
--DROP rmessages
DROP TABLE rmessages;
--DROP reinherit_function
DROP FUNCTION reinherit_function();
--UPDATE create_table_function TO GET RID OF INHERITANCE FROM messages AND rmessages
CREATE OR REPLACE FUNCTION create_table_function( tbl_date DATE, tbl_time TIME )
RETURNS BOOLEAN AS $$
DECLARE
    table_name CHAR(25);
    const_name CHAR(10);
    time_from TIMESTAMP;
    time_to TIMESTAMP;
BEGIN
    time_from := date_trunc( 'hour', tbl_date + tbl_time );
    time_to := time_from + INTERVAL '1 hour';
    table_name := 'messages_' || to_char(time_from, 'yyyy_mm_dd_hh24');
    const_name := 'const_' || to_char(time_from, 'hh24');
    EXECUTE ( 'CREATE TABLE ' || table_name ||  ' (LIKE messages INCLUDING DEFAULTS)' );
    EXECUTE ( 'ALTER TABLE ' || table_name || ' ADD PRIMARY KEY (id)' );
    IF ( SELECT create_fts_index FROM settings ) THEN
		EXECUTE ( 'CREATE INDEX ' || table_name || '_key ON ' || table_name || ' USING gin( to_tsvector(''english'', fts) )');
	END IF;
    IF ( register_table( table_name, get_location_mask( 'empty' ) ) = FALSE ) THEN
	RETURN FALSE;
    END IF;
    RETURN TRUE;
EXCEPTION
    WHEN OTHERS THEN
	RAISE NOTICE 'Error number:%', SQLSTATE;
	RETURN FALSE;
END;
$$
LANGUAGE plpgsql;
--UPDATE db VERSION
UPDATE service SET version = 9;
